<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.15"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>My Project: HttpParser.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">My Project
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.15 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
</div><!-- top -->
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">HttpParser.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * HttpParser.h</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Aug 28, 2017</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: kolban</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef CPP_UTILS_HTTPPARSER_H_</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define CPP_UTILS_HTTPPARSER_H_</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="preprocessor">#include &lt;string&gt;</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="preprocessor">#include &lt;map&gt;</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="preprocessor">#include &quot;Socket.h&quot;</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;</div><div class="line"><a name="l00014"></a><span class="lineno"><a class="line" href="classHttpParser.html">   14</a></span>&#160;<span class="keyword">class </span><a class="code" href="classHttpParser.html">HttpParser</a> {</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="keyword">public</span>:</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;    <a class="code" href="classHttpParser.html">HttpParser</a>();</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;    <span class="keyword">virtual</span> ~<a class="code" href="classHttpParser.html">HttpParser</a>();</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;    std::string getBody();</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;    std::string <a class="code" href="classHttpParser.html#ac41defb5ee108129a23e3b5466343627">getHeader</a>(<span class="keyword">const</span> std::string&amp; name);</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    std::map&lt;std::string, std::string&gt; getHeaders();</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    std::string getMethod();</div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;    std::string getURL();</div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;    std::string getVersion();</div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;    std::string getStatus();</div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;    std::string getReason();</div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classHttpParser.html#abbc43df85a98a2c8c48bf9715ccf23e5">hasHeader</a>(<span class="keyword">const</span> std::string&amp; name);</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;    <span class="keywordtype">void</span> parse(std::string message);</div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    <span class="keywordtype">void</span> parse(<a class="code" href="classSocket.html">Socket</a> s);</div><div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    <span class="keywordtype">void</span> <a class="code" href="classHttpParser.html#a6b5b742304eab756458af6502de9bd54">parseResponse</a>(std::string message);</div><div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;</div><div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;<span class="keyword">private</span>:</div><div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    std::string m_method;</div><div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    std::string m_url;</div><div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    std::string m_version;</div><div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    std::string m_body;</div><div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    std::string m_status;</div><div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;    std::string m_reason;</div><div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;    std::map&lt;std::string, std::string&gt; m_headers;</div><div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;    <span class="keywordtype">void</span> dump();</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;    <span class="keywordtype">void</span> parseRequestLine(std::string&amp; line);</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    <span class="keywordtype">void</span> parseStatusLine(std::string&amp; line);</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;};</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* CPP_UTILS_HTTPPARSER_H_ */</span><span class="preprocessor"></span></div><div class="ttc" id="classHttpParser_html_abbc43df85a98a2c8c48bf9715ccf23e5"><div class="ttname"><a href="classHttpParser.html#abbc43df85a98a2c8c48bf9715ccf23e5">HttpParser::hasHeader</a></div><div class="ttdeci">bool hasHeader(const std::string &amp;name)</div><div class="ttdoc">Determine if we have a header of the given name.</div><div class="ttdef"><b>Definition:</b> HttpParser.cpp:182</div></div>
<div class="ttc" id="classSocket_html"><div class="ttname"><a href="classSocket.html">Socket</a></div><div class="ttdoc">Encapsulate a socket.</div><div class="ttdef"><b>Definition:</b> Socket.h:62</div></div>
<div class="ttc" id="classHttpParser_html_ac41defb5ee108129a23e3b5466343627"><div class="ttname"><a href="classHttpParser.html#ac41defb5ee108129a23e3b5466343627">HttpParser::getHeader</a></div><div class="ttdeci">std::string getHeader(const std::string &amp;name)</div><div class="ttdoc">Retrieve the value of the named header.</div><div class="ttdef"><b>Definition:</b> HttpParser.cpp:141</div></div>
<div class="ttc" id="classHttpParser_html_a6b5b742304eab756458af6502de9bd54"><div class="ttname"><a href="classHttpParser.html#a6b5b742304eab756458af6502de9bd54">HttpParser::parseResponse</a></div><div class="ttdeci">void parseResponse(std::string message)</div><div class="ttdoc">Parse a response message.</div><div class="ttdef"><b>Definition:</b> HttpParser.cpp:275</div></div>
<div class="ttc" id="classHttpParser_html"><div class="ttname"><a href="classHttpParser.html">HttpParser</a></div><div class="ttdef"><b>Definition:</b> HttpParser.h:14</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.15
</small></address>
</body>
</html>
